
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>JavaWeb文件上传下载实例讲解(酷炫的文件上传技术)_java / iVAN</title>

    <meta name="description" content="JavaWeb文件上传下载实例讲解(酷炫的文件上传技术)_java 一.课程概述 在Web应用系统开发中,文件上传功能是非常常用的功能,今天来主要讲讲JavaWeb中的文件上传功能的相关技术实现,并且随着互联网技术的飞速发展,用户对网站的体验要求越来越高,在文件上传功能的技术上也出现许多创新点,例如异步上传文件,拖拽式上传,黏贴上传,上传进度监控,文件缩略图,大文件断点续传,大文件秒传等等. 本课程需要的基础知识: 了解基本的Http协议内容 基本IO流操作技术 Servlet基础知识 javascript/jQuery技术基础知识 二.文件上传的基础 对于文件">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">JavaWeb文件上传下载实例讲解(酷炫的文件上传技术)_java</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><strong>一、课程概述</strong></p>
<p>在Web应用系统开发中，文件上传功能是非常常用的功能，今天来主要讲讲JavaWeb中的文件上传功能的相关技术实现，并且随着互联网技术的飞速发展，用户对网站的体验要求越来越高，在文件上传功能的技术上也出现许多创新点，例如异步上传文件，拖拽式上传，黏贴上传，上传进度监控，文件缩略图，大文件断点续传，大文件秒传等等。</p>
<p><strong>本课程需要的基础知识：</strong></p>
<p>了解基本的Http协议内容</p>
<p>基本IO流操作技术</p>
<p>Servlet基础知识</p>
<p>javascript/jQuery技术基础知识</p>
<p><strong>二、文件上传的基础</strong></p>
<p>对于文件上传，浏览器在上传的过程中是将文件以流的形式提交到服务器端的，并且所有流数据都会随着Http请求携带到服务器端。所以，文件上传时的请求内容格式要能够基本看懂。</p>
<p>文件上传页面：</p>
<pre>
&lt;form action="/itheimaUpload/UploadServlet" method="post" enctype="multipart/form-data"&gt;
请选择上传的文件：&lt;input type="file" name="attach"/&gt;&lt;br/&gt;
&lt;input type="submit" value="提交"/&gt;
&lt;/form&gt;</pre>
<p>Http请求内容：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTExNzEwNDcwMzE1LnBuZw==.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTExNzEwNDcwMzE2LnBuZw==.jpg"></p>
<p><strong>三、Java后台使用Servlet接收文件</strong></p>
<p>如果使用Servlet获取上传文件的输入流然后再解析里面的请求参数是比较麻烦，所以一般后台选择采用Apache的开源工具common-fileupload这个文件上传组件。</p>
<pre>
//Java后台代码：Commons-fileUpload组件上传文件
public class UploadServlet extends HttpServlet {
public void doGet(HttpServletRequest request, HttpServletResponse response)
throws ServletException, IOException {
//1.配置缓存
DiskFileItemFactory factory = new DiskFileItemFactory(1*1024*1024,new File("c:/tempFiles/"));
//2.创建ServleFileUpload对象
ServletFileUpload sfu = new ServletFileUpload(factory);
//解决文件名称中文问题
sfu.setHeaderEncoding("utf-8");
//3.解析
try {
List&lt;FileItem&gt; list = sfu.parseRequest(request);
//解析所有内容
if(list!=null){
for(FileItem item:list){
//判断是否为普通表单参数
if(item.isFormField()){
//普通表单参数
//获取表单的name属性名称
String fieldName = item.getFieldName();
//获取表单参数值
String value = item.getString("utf-8");
}else{
//文件
if(item.getName()!=null &amp;&amp; !item.getName().equals("")) {
//保存到服务器硬盘
FileUtils.copyInputStreamToFile(item.getInputStream(), new File("c:/targetFiles/"+item.getName()));
item.delete();
}
}
}
}
} catch (FileUploadException e) {
e.printStackTrace();
}
}
public void doPost(HttpServletRequest request, HttpServletResponse response)
throws ServletException, IOException {
doGet(request, response);
}
}</pre>
<p><strong>四、使用WebUploader上传组件</strong></p>
<p>文件上传页面的前端我们可以选择使用一些比较好用的上传组件，例如百度的开源组件WebUploader，这个组件基本能满足文件上传的一些日常所需功能，如异步上传文件，拖拽式上传，黏贴上传，上传进度监控，文件缩略图，甚至是大文件断点续传，大文件秒传。</p>
<p><strong>下载WebUpload组件</strong></p>
<p>http://fex.baidu.com/webuploader/ 到WebUpload官网下载WebUpload包</p>
<p>WebUpload目录结构：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTExNzEwNDcwMzE3LnBuZw==.jpg"></p>
<p>基本文件上传Demo（包含上传进度）</p>
<p>前端</p>
<p>1.1 在页面导入所需css，js</p>
<pre>
&lt;link rel="stylesheet" type="text/css"
href="${pageContext.request.contextPath}/css/webuploader.css"&gt;
&lt;script type="text/javascript"
src="${pageContext.request.contextPath }/js/jquery-1.10.2.min.js"&gt;&lt;/script&gt;
&lt;script type="text/javascript"
src="${pageContext.request.contextPath }/js/webuploader.js"&gt;&lt;/script&gt;</pre>
<p>1.2 编写上传页面标签</p>
<pre>
&lt;!-- 上传div --&gt;
&lt;div id="uploader"&gt;
&lt;!-- 显示文件列表信息 --&gt;
&lt;ul id="fileList"&gt;&lt;/ul&gt;
&lt;!-- 选择文件区域 --&gt;
&lt;div id="filePicker"&gt;点击选择文件&lt;/div&gt;
&lt;/div&gt;</pre>
<p>1.3 编写webupload代码</p>
<pre>
&lt;script type="text/javascript"&gt;
//1.初始化WebUpload，以及配置全局的参数
var uploader = WebUploader.create(
{
//flashk控件的地址
swf: "${pageContext.request.contextPath}/js/Uploader.swf",
//后台提交地址
server:"${pageContext.request.contextPath}/UploadServlet",
//选择文件控件的标签
pick:"#filePicker",
//自动上传文件
auto:true,
}
);
//2.选择文件后，文件信息队列展示
// 注册fileQueued事件：当文件加入队列后触发
// file: 代表当前选择的文件
uploader.on("fileQueued",function(file){
//追加文件信息div
$("#fileList").append("&lt;div id='"+file.id+"' class='fileInfo'&gt;&lt;span&gt;"+file.name+"&lt;/span&gt;&lt;div class='state'&gt;等待上传...&lt;/div&gt;&lt;span class='text'&gt;&lt;/span&gt;&lt;/div&gt;");
});
//3.注册上传进度监听
//file: 正在上传的文件
//percentage: 当前进度的比例。最大为1.例如:0.2
uploader.on("uploadProgress",function(file,percentage){
var id = $("#"+file.id);
//更新状态信息
id.find("div.state").text("上传中...");
//更新上传百分比
id.find("span.text").text(Math.round(percentage*100)+"%");
});
//4.注册上传完毕监听
//file:上传完毕的文件
//response:后台回送的数据，以json格式返回
uploader.on("uploadSuccess",function(file,response){
//更新状态信息
$("#"+file.id).find("div.state").text("上传完毕");
});</pre>
<p>2）后端Servlet代码</p>
<pre>
DiskFileItemFactory factory = new DiskFileItemFactory();
ServletFileUpload sfu = new ServletFileUpload(factory);
sfu.setHeaderEncoding("utf-8");
try {
List&lt;FileItem&gt; items = sfu.parseRequest(request);
for(FileItem item:items){
if(item.isFormField()){
//普通信息
}else{
//文件信息
//判断只有文件才需要进行保存处理
System.out.println("接收的文件名称:"+item.getName());
//拷贝文件到后台的硬盘
FileUtils.copyInputStreamToFile(item.getInputStream(), new File(serverPath+"/"+item.getName()));
System.out.println("文件保存成功");
}
}
} catch (FileUploadException e) {
e.printStackTrace();
}</pre>
<p><strong>生成图片缩略图</strong></p>
<p>关键点：调用uploader.makeThumb()方法生成缩略图</p>
<pre>
uploader.on("fileQueued",function(file){
//追加文件信息div
$("#fileList").append("&lt;div id='"+file.id+"' class='fileInfo'&gt;&lt;img/&gt;&lt;span&gt;"+file.name+"&lt;/span&gt;&lt;div class='state'&gt;等待上传...&lt;/div&gt;&lt;span class='text'&gt;&lt;/span&gt;&lt;/div&gt;");
//制造图片缩略图：调用makeThumb()方法
//error: 制造缩略图失败
//src: 缩略图的路径
uploader.makeThumb(file,function(error,src){
var id = $("#"+file.id);
//如果失败，则显示“不能预览”
if(error){
id.find("img").replaceWith("不能预览");
}
//成功，则显示缩略图到指定位置
id.find("img").attr("src",src);
});
});</pre>
<p><strong>拖拽，黏贴上传</strong></p>
<p>1）页面添加拖拽区域的div</p>
<pre>
&lt;!-- 上传div --&gt;
&lt;div id="uploader"&gt;
&lt;!-- 文件拖拽区域 --&gt;
&lt;div id="dndArea"&gt;
&lt;p&gt;将文件直接拖拽到这里即可自动上传&lt;/p&gt;
&lt;/div&gt;
&lt;!-- 显示文件列表信息 --&gt;
&lt;ul id="fileList"&gt;&lt;/ul&gt;
&lt;!-- 选择文件区域 --&gt;
&lt;div id="filePicker"&gt;点击选择文件&lt;/div&gt;
&lt;/div&gt;</pre>
<p>2）在webuploader的全局配置参数添加拖拽功能的参数</p>
<pre>
//1.初始化WebUpload，以及配置全局的参数
var uploader = WebUploader.create(
{
//flashk控件的地址
swf: "${pageContext.request.contextPath}/js/Uploader.swf",
//后台提交地址
server:"${pageContext.request.contextPath}/UploadServlet",
//选择文件控件的标签
pick:"#filePicker",
//自动上传文件
auto:true,
//开启拖拽功能，指定拖拽区域
dnd:"#dndArea",
//禁用页面其他地方的拖拽功能，防止页面直接打开文件
disableGlobalDnd:true
//开启黏贴功能
paste:"#uploader"
}
);</pre>
<p><strong>大文件分块上传</strong></p>
<p>1）在webuploader全局参数中添加分块上传参数</p>
<pre>
//1.初始化WebUpload，以及配置全局的参数
var uploader = WebUploader.create(
{
//flashk控件的地址
swf: "${pageContext.request.contextPath}/js/Uploader.swf",
//后台提交地址
server:"${pageContext.request.contextPath}/UploadServlet",
//选择文件控件的标签
pick:"#filePicker",
//自动上传文件
auto:true,
//开启拖拽功能，指定拖拽区域
dnd:"#dndArea",
//禁用页面其他地方的拖拽功能，防止页面直接打开文件
disableGlobalDnd:true,
//开启黏贴功能
paste:"#uploader",
//分块上传设置
//是否分块上传
chunked:true,
//每块文件大小（默认5M）
chunkSize:5*1024*1024,
//开启几个并发线程（默认3个）
threads:3,
//在上传当前文件时，准备好下一个文件
prepareNextFile:true
}
);</pre>
<p>2）监控上传文件的三个时间点</p>
<p>添加以上三个配置后，会发现当文件超过5M时，webuploader自动把文件会分几个请求发送给后台</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTExNzEwNDcwMzE4LnBuZw==.jpg"></p>
<p>每个分块请求，包含的信息：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTExNzEwNDcwMzE5LnBuZw==.jpg"></p>
<p>可以监听文件分块上传的三个重要的时间点。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTExNzEwNDcwMzIwLnBuZw==.jpg"></p>
<pre>
before-send-file : 在所有分块发送之前调用
before-send: 如果有分块，在每个分块发送之前调用
after-send-file: 在所有分块发送完成之后调用
//5.监控文件上传的三个时间点(注意：该段代码必须放在WebUploader.create之前)
//时间点1：:所有分块进行上传之前（1.可以计算文件的唯一标记;2.可以判断是否秒传）
//时间点2： 如果分块上传，每个分块上传之前（1.询问后台该分块是否已经保存成功，用于断点续传）
//时间点3：所有分块上传成功之后（1.通知后台进行分块文件的合并工作）
WebUploader.Uploader.register({
"before-send-file":"beforeSendFile",
"before-send":"beforeSend",
"after-send-file":"afterSendFile"
},{
//时间点1：:所有分块进行上传之前调用此函数
beforeSendFile:function(){
//1.计算文件的唯一标记，用于断点续传和秒传
//2.请求后台是否保存过该文件，如果存在，则跳过该文件，实现秒传功能
},
//时间点2：如果有分块上传，则 每个分块上传之前调用此函数
beforeSend:function(){
//1.请求后台是否保存过当前分块，如果存在，则跳过该分块文件，实现断点续传功能
},
//时间点3：所有分块上传成功之后调用此函数
afterSendFile:function(){
//1.如果分块上传，则通过后台合并所有分块文件
}
});</pre>
<p>before-send-file逻辑：</p>
<pre>
//利用md5File（）方法计算文件的唯一标记符
//该函数接收一个deferred
beforeSendFile:function(file){
//创建一个deffered
var deferred = WebUploader.Deferred();
//1.计算文件的唯一标记，用于断点续传和秒传
(new WebUploader.Uploader()).md5File(file,0,5*1024*1024)
.progress(function(percentage){
$("#"+file.id).find("div.state").text("正在获取文件信息...");
})
.then(function(val){
uniqueFileTag = val;
$("#"+file.id).find("div.state").text("成功获取文件信息");
//只有文件信息获取成功，才进行下一步操作
deferred.resolve();
});
//alert(uniqueFileTag);
//2.请求后台是否保存过该文件，如果存在，则跳过该文件，实现秒传功能
//返回deffered
return deferred.promise();
}</pre>
<p>before-send逻辑：</p>
<pre>
//向后台发送当前文件的唯一标记，用于后台创建保存分块文件的目录
beforeSend:function(){
//携带当前文件的唯一标记到后台，用于让后台创建保存该文件分块的目录
this.owner.options.formData.fileMd5 = fileMd5;
}</pre>
<p>3）后台需要保存所有分块文件</p>
<pre>
//为每个文件创建一个目录，并保存这个文件的所有分块文件
//判断是否已经分块上传
if(chunks!=null){
System.out.println("分块处理...");
//进行分块上传了
//建立一个临时目录，用于保存所有分块文件
File chunksDir = new File(serverPath+"/"+fileMd5);
if(!chunksDir.exists()){
chunksDir.mkdir();
}
if(chunk!=null){
//保存分块文件
File chunkFile = new File(chunksDir.getPath()+"/"+chunk);
FileUtils.copyInputStreamToFile(item.getInputStream(), chunkFile);
}</pre>
<p>4）前台通知后台合并所有分块文件</p>
<pre>
//前台通知后台合并文件
after-send-file逻辑：
afterSendFile:function(file){
//1.如果分块上传，则通过后台合并所有分块文件
//请求后台合并文件
$.ajax(
{
type:"POST",
url:"${pageContext.request.contextPath}/UploadCheckServlet?action=mergeChunks",
data:{
//文件唯一标记
fileMd5:fileMd5,
//文件名称
fileName:file.name
},
dataType:"json",
success:function(response){
alert(response.msg);
}
}
);
}
//后台合并所有分块文件
if("mergeChunks".equals(action)){
System.out.println("开始合并文件...");
//合并文件
String fileMd5 = request.getParameter("fileMd5");
String fileName = request.getParameter("fileName");
//读取目录里面的所有文件
File f = new File(serverPath+"/"+fileMd5);
File[] fileArray = f.listFiles(new FileFilter(){
//排除目录，只要文件
public boolean accept(File pathname) {
if(pathname.isDirectory()){
return false;
}
return true;
}
});
//转成集合，便于排序
List&lt;File&gt; fileList = new ArrayList&lt;File&gt;(Arrays.asList(fileArray));
//从小到大排序
Collections.sort(fileList, new Comparator&lt;File&gt;() {
public int compare(File o1, File o2) {
if(Integer.parseInt(o1.getName()) &lt; Integer.parseInt(o2.getName())){
return -1;
}
return 1;
}
});
File outputFile = new File(serverPath+"/"+fileName);
//创建文件
outputFile.createNewFile();
//输出流
FileChannel outChannel = new FileOutputStream(outputFile).getChannel();
//合并
FileChannel inChannel;
for(File file : fileList){
inChannel = new FileInputStream(file).getChannel();
inChannel.transferTo(0, inChannel.size(), outChannel);
inChannel.close();
//删除分片
file.delete();
}
//清除文件夹
File tempFile = new File(serverPath+"/"+fileMd5);
if(tempFile.isDirectory() &amp;&amp; tempFile.exists()){
tempFile.delete();
}
//关闭流
outChannel.close();
response.setContentType("text/html;charset=utf-8");
response.getWriter().write("{\"msg\":\"合并成功\"}");
}</pre>
<p><strong>大文件断点续传</strong></p>
<p>在实现了分块上传的基础上，实现断点续传就非常简单了！！！</p>
<p><strong>前端：</strong></p>
<pre>
//时间点2：如果有分块上传，则 每个分块上传之前调用此函数
//block:代表当前分块对象
beforeSend:function(block){
//1.请求后台是否保存过当前分块，如果存在，则跳过该分块文件，实现断点续传功能
var deferred = WebUploader.Deferred();
//请求后台是否保存完成该文件信息，如果保存过，则跳过，如果没有，则发送该分块内容
$.ajax(
{
type:"POST",
url:"${pageContext.request.contextPath}/UploadCheckServlet?action=checkChunk",
data:{
//文件唯一标记
fileMd5:fileMd5,
//当前分块下标
chunk:block.chunk,
//当前分块大小
chunkSize:block.end-block.start
},
dataType:"json",
success:function(response){
if(response.ifExist){
//分块存在，跳过该分块
deferred.reject();
}else{
//分块不存在或者不完整，重新发送该分块内容
deferred.resolve();
}
}
}
);
//携带当前文件的唯一标记到后台，用于让后台创建保存该文件分块的目录
this.owner.options.formData.fileMd5 = fileMd5;
return deferred.promise();
},</pre>
<p>后台：</p>
<pre>
//检查该分块是否存在或者完整保存
private void checkChunk(HttpServletRequest request,
HttpServletResponse response) throws IOException,
FileNotFoundException {
System.out.println("checkChunk...");
String fileMd5 = request.getParameter("fileMd5");
String chunk = request.getParameter("chunk");
String chunkSize = request.getParameter("chunkSize");
File checkFile = new File(serverPath+"/"+fileMd5+"/"+chunk);
response.setContentType("text/html;charset=utf-8");
//检查文件是否存在，且大小是否一致
if(checkFile.exists() &amp;&amp; checkFile.length()==Integer.parseInt(chunkSize)){
response.getWriter().write("{\"ifExist\":1}");
}else{
response.getWriter().write("{\"ifExist\":0}");
}
}</pre>
<p><strong>文件秒传</strong></p>
<p>在所有分块请求之前，就已经可以进行实现秒传功能！！！</p>
<p><strong>前端：</strong></p>
<pre>
beforeSendFile:function(file){
//创建一个deffered
var deferred = WebUploader.Deferred();
//1.计算文件的唯一标记，用于断点续传和秒传
(new WebUploader.Uploader()).md5File(file,0,5*1024*1024)
.progress(function(percentage){
$("#"+file.id).find("div.state").text("正在获取文件信息...");
})
.then(function(val){
fileMd5 = val;
$("#"+file.id).find("div.state").text("成功获取文件信息");
//2.请求后台是否保存过该文件，如果存在，则跳过该文件，实现秒传功能
$.ajax(
{
type:"POST",
url:"${pageContext.request.contextPath}/UploadCheckServlet?action=fileCheck",
data:{
//文件唯一标记
fileMd5:fileMd5
},
dataType:"json",
success:function(response){
if(response.ifExist){
$("#"+file.id).find("div.state").text("秒传成功");
//如果存在，则跳过该文件，秒传成功
deferred.reject();
}else{
//继续上传
deferred.resolve();
}
}
}
);
});
//返回deffered
return deferred.promise();
},</pre>
<p>后台：</p>
<pre>
//检查文件的md5数据是否跟在数据库存在
private void fileCheck(HttpServletRequest request,
HttpServletResponse response) throws IOException,
FileNotFoundException {
String fileMd5 = request.getParameter("fileMd5");
//模拟数据库
Map&lt;String,String&gt; database = new HashMap&lt;String,String&gt;();
database.put("576018603f4091782b68b78af85704a1", "01.课程回顾.itcast");
response.setContentType("text/html;charset=utf-8");
if(database.containsKey(fileMd5)){
response.getWriter().write("{\"ifExist\":1}");
}else{
response.getWriter().write("{\"ifExist\":0}");
}
}</pre>
<p>以上所述是小编给大家介绍的JavaWeb文件上传下载实例讲解(酷炫的文件上传技术)，希望对大家有所帮助，如果大家有任何疑问请给我留言，小编会及时回复大家的。在此也非常感谢大家对网站的支持！</p>
<p>以上是小编为您精心准备的的内容，在的博客、问答、公众号、人物、课程等栏目也有的相关内容，欢迎继续使用右上角搜索按钮进行搜索javaweb文件上传<br />
                                    javaweb文件下载<br />
                                    java web项目实例讲解、webuploader上传实例、javaweb文件上传 实例、酷炫的引导层动画实例、web系统酷炫消息提示，以便于您获取更多的相关知识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-04 09:31:23</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/javaweb%e6%96%87%e4%bb%b6%e4%b8%8b%e8%bd%bd/" title="javaweb文件下载">javaweb文件下载</a>, <a href="https://www.iamivan.net/tag/javaweb%e6%96%87%e4%bb%b6%e4%b8%8a%e4%bc%a0/" title="javaweb文件上传">javaweb文件上传</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>JavaWeb文件上传下载实例讲解(酷炫的文件上传技术)_java的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBkx2oM.html" rel="bookmark">jQuery&period;uploadify文件上传组件实例讲解&lowbar;jquery</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.jquery.uploadify简介 在ASP.NET中上传的控件有很多,比如.NET自带的FileUpload,以及SWFUpload,Uploadify等等,尤其后面两个控件的用户体验比较好,无刷新,带上传进度等等.在最近的短信平台开发中,使用Uploadify进行文件上传. Uploadify官网地址是:http://www.uploadify.com/ 可满足项目开发需求. 下载地址:http://www.uploadify.com/wp-content/uploads/files/			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKmeoZp.html" rel="bookmark">最详细的文件上传下载实例详解&lpar;推荐&rpar;&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在Web应用系统开发中,文件上传和下载功能是非常常用的功能,今天来讲一下JavaWeb中的文件上传和下载功能的实现. 对于文件上传,浏览器在上传的过程中是将文件以流的形式提交到服务器端的,如果直接使用Servlet获取上传文件的输入流然后再解析里面的请求参数是比较麻烦,所以一般选择采用apache的开源工具common-fileupload这个文件上传组件.这个common-fileupload上传组件的jar包可以去apache官网上面下载,也可以在struts的lib文件夹下面找到,stru			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7xyv4b.html" rel="bookmark">PHP实现文件上传下载实例&lowbar;php实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文介绍了PHP实现文件上传与下载,现在就分享给大家,也给大家做个参考.一起跟随小编过来看看吧. 一.上传原理与配置 1.1 原理 将客户端文件上传到服务器端,再将服务器端的文件(临时文件)移动到指定目录即可. 1.2 客户端配置 所需:表单页面(选择上传文件): 具体而言:发送方式为POST,添加enctype=&quot;multipart/form-data&quot;属性,两者缺一不可(但是,优缺点并存,这里也限定了上传的方式和上传的文件之后的调用等方面,后面会说到) &lt;!DOCTYPE h			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0Wo4mb.html" rel="bookmark">java web 怎么上传ppt，excel是可以上传下载的，但是ppt怎么做到上传和下载</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 java web 怎么上传ppt,excel是可以上传下载的,但是ppt怎么做到上传和下载 用的oracle数据库,java是springmvc+mybatis 解决方案 如何上传PPT到博客 解决方案二: 上传 和 下载 的方法 不会因为后缀名不一样而有改变.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5Nr2az.html" rel="bookmark">自动下载-怎样实现不上网站下载网站最新的文件，比如说下载政府网站的最新政策文件？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 怎样实现不上网站下载网站最新的文件,比如说下载政府网站的最新政策文件? 现在政府文件都是放在网站上的,所以每天得上政府网站去看看有没有最新的文件,有没有办法不上网站,写程序自动监测最新文件,如果有则下载下来? 解决方案 自己分析存在文件的页面,然后用类似火车头的采集软件定时采集页面分析url进行下载 解决方案二: 可以使用webserver 解决方案三: 发送HTTP请求,解析html,拿到页面连接,下载,保存 解决方案四: 写个job好了咯,只要你清楚如何区分新文件的规则.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdm8P2z.html" rel="bookmark">EDI中JAVA通过FTP工具实现文件上传下载实例&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近接手一个EDI项目,收获颇多.其实我在第一家公司是接触过EDI的,当初我们用EDI主要实现了订单数据传输,客户向我们下达采购订单,通过VPN及FTP工具将采购订单以约定的报文形式放到指定的文件服务器中,然后我们EDI系统会定时去文件服务器中获取报文,最后解析并生成我们的销售订单.这些年过去了,我仍记着当初用的最多的是EDI850.EDI855.  一.首先介绍一下EDI的概念 Electronic data interchange,电子数据交换. EDI其实就是把原来纸质的订单/发货通知等业			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MR146Gb.html" rel="bookmark">一个完整的php文件上传类实例讲解&lowbar;php实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				这个文件上传类可以自定上传文件大小与上传文件类型及文件保存地址,在使用过程中有一个问题就是如果是中文文件名进行上传就会出现乱码,所以大家解决办法就是把页面保存成uft8即可解决. 下面就是为大家分享的代码: &lt;?php define('NO_FILE', '不存在上传文件'); define('NOT_ALLOW_EXT', '文件类型不在允许范围内'); define('NOT_ALLOW_SIZE', '文件大小不在允许范围内'); define('HAS_THE_FILE', '该文件已经			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAkGvnz.html" rel="bookmark">JAVA中使用FTPClient实现文件上传下载实例代码&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在java程序开发中,ftp用的比较多,经常打交道,比如说向FTP服务器上传文件.下载文件,本文给大家介绍如何利用jakarta commons中的FTPClient(在commons-net包中)实现上传下载文件. 一.上传文件 原理就不介绍了,大家直接看代码吧 /** * Description: 向FTP服务器上传文件 * @Version1.0 Jul 27, 2008 4:31:09 PM by 崔红保(cuihongbao@d-heaven.com)创建 * @param url F			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p86jgob.html" rel="bookmark">PHP实现文件上传下载实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文介绍了PHP实现文件上传与下载,现在就分享给大家,也给大家做个参考.一起跟随小编过来看看吧. 一.上传原理与配置 1.1 原理 将客户端文件上传到服务器端,再将服务器端的文件(临时文件)移动到指定目录即可. 1.2 客户端配置 所需:表单页面(选择上传文件): 具体而言:发送方式为POST,添加enctype=&quot;multipart/form-data&quot;属性,两者缺一不可(但是,优缺点并存,这里也限定了上传的方式和上传的文件之后的调用等方面,后面会说到) &lt;!DOCTYPE h			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qzDYPXb.html" rel="bookmark" class="title">win8系统怎样去掉图标下面的文字</a>
					<div>
						  最近,有不少win8系统用户反映自己在使用IE浏览器同时打开多个网页时,因为每个网站字体大小不一致,导致自己看着非常不舒服.那么,遇到这种情况该怎么办?其实,我们可以完全可以通过固定Win8系统中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zeAvNz.html" rel="bookmark" class="title">本源XML数据库Xindice 介绍 （1&period;0版）</a>
					<div>
						xml|数据|数据库 (Xindice当前的版本是1.1b4,已经做了较大改动,本文是1.0版的说明文档译文,仅供参考.部分改动在文中略做说明. ----译者:ksu99) 什么是Xindice Xi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qzDV9WM.html" rel="bookmark" class="title">SEO行业也玩&OpenCurlyDoubleQuote;潜规则&rdquo;</a>
					<div>
						如今做网站推广的朋友们都知道seo行业有不少的&quot;潜规则&quot;,就像是娱乐行业一样.许多人玩&quot;潜规则&quot;,同时也可能被&quot;潜规则&quot;.这是很无奈的事情, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Vzww3Oz.html" rel="bookmark" class="title">2012年SEO仍不可触碰的三大禁区</a>
					<div>
						   相信各位站长对于SEO肯定是十分熟悉,它是目前比较流行的网络营销模式,通过对相关关键字的优化以此增加网站的透明度,为自己的争取潜在的客户.正是因为SEO拥有如此大的作用,才使得各位站长尤其是新手 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrK8dmp.html" rel="bookmark" class="title">Bootstrap基础学习</a>
					<div>
						Bootstrap是一个基于栅格结构的前端结构框架(当然也有JS,JQuery),它的优点是内容框架能够迅速搭建起来,基于媒介查询可以使搭建的页面迅速的适应不同的用户端,无论是手机,平板,还是PC,基 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3N090z.html" rel="bookmark" class="title">如何破解邮箱密码</a>
					<div>
						对电脑不是很熟悉的朋友最好还是别去破解别人的密码,这虽然是可以破解,但是也不是什么好差事.一般对于一些黑客来说肯定不是很麻烦,可是门外汉的话那就是不好搞了.那么黑客是怎么窃取密码的呢? 1.邮件服务器 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDAl96b.html" rel="bookmark" class="title">善用Win7家长控制 解决孩子上网无节制</a>
					<div>
						给孩子配置了电脑,本是希望能够让孩子的学习得到提高,但也可能适得其反,有些孩子过度沉迷于网络无法约束,甚至影响了身体健康.善用Win7系统内置家长控制功能,不仅可以限制孩子使用计算机的时间,还可以限制 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDA23Bb.html" rel="bookmark" class="title">php通过array</a>
					<div>
						 这篇文章主要介绍了php通过array_push()函数添加多个变量到数组末尾的方法,涉及php中array_push()函数操作数组的技巧,需要的朋友可以参考下     本文实例讲述了php通过a ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVnvOmz.html" rel="bookmark" class="title">Windows如何解决Defender过期无法更新问题</a>
					<div>
						  Windows 8.1和Windows 10自带安全防护工具Windows Defender需要最新病毒库的支持才能发挥作用.当遇到Windows Defender无法更新&quot;无法启动服务 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/badD7Nz.html" rel="bookmark" class="title">双击＂添加和删除程序＂，弹出Value creation failed ＂at line</a>
					<div>
						电脑出现这个问题的截图: 1 问题具体描述 只有这个问题,其他方面都没问题.而且通过360安全卫士,QQ管家之类的软件卸载软件都没问题.但是控制面板里面的&quot;添加与删除程序&quot;打开就会 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg37P8M.html" rel="bookmark" class="title">&period;Net 的数学库计算精度太差？？</a>
					<div>
						问题描述 在程序中要计算一个很小的数的指数,即Math.Exp(x)其中x非常小.结果发现居然计算出来的结果是错的.用vc2010验证了一下,也是错的.在vc6下面计算,得到了正确的结果.怎么微软的库 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgVEw3b.html" rel="bookmark" class="title">分辨率-画面插值加大显示尺寸，请各位大神帮帮忙，谢谢，急、急、急、在线等</a>
					<div>
						问题描述 画面插值加大显示尺寸,请各位大神帮帮忙,谢谢,急.急.急.在线等 现在我有台机子是双镜头的,但是画面显示分辨率的尺寸为1920*720,能不能通过插值的算法把尺寸改为1920*1080,请各 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvrxgVM.html" rel="bookmark" class="title">android layout-android-layout&lowbar;gravity的问题</a>
					<div>
						问题描述 android-layout_gravity的问题 帮忙看一下我设置layout_gravity哪出现问题了. &lt;Button android:id=&quot;@+id/test_b ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8kBV3M.html" rel="bookmark" class="title">Bluehost已经被EIG公司巨资收购</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 目前美国的主机业兼并风潮不断,最为重磅的消息应该就是Bluehost被EIG集团巨资收购,具体的收购价格并没有向外界宣布,可是仅从09年Bluehost ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm6w6jz.html" rel="bookmark" class="title">sql-一道关于数据库的面试题，看着很简单，但我就是不会写。求指导</a>
					<div>
						问题描述 一道关于数据库的面试题,看着很简单,但我就是不会写.求指导 解决方案 oracle的http://www.cnblogs.com/luluping/archive/2012/07/26/26 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxYl97p.html" rel="bookmark" class="title">jFrame打开新窗体，并关闭当前窗体</a>
					<div>
						问题描述 请问如何实现,打开一个新窗体,并把当前窗体关闭. 解决方案 解决方案二:importjava.awt.*;importjava.awt.event.*;importjavax.swing.* ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKYdQ7p.html" rel="bookmark" class="title">Canal BinlogChange&lpar;mariadb5&sol;10&rpar;</a>
					<div>
						背景 先前开源了一个开源项目: [阿里巴巴开源项目: 基于mysql数据库binlog的增量订阅&amp;消费]  本文主要是介绍一下canal支持mariadb协议上的变化.    协议变化 mar ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5RZ8nz.html" rel="bookmark" class="title">Xamarin生成的APK大小分析</a>
					<div>
						原文:Xamarin生成的APK大小分析 刚接触Xamarin都会被Xamarin的售价吓一跳,另外就是它生成的APK大小,官方也有相关的说明,这里加上自己的理解同意讲解下: 以下是针对Android ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlL0QVM.html" rel="bookmark" class="title">文档-poi的WordExtractor解析word03文件，出现文件中不存在的一个网址</a>
					<div>
						问题描述 poi的WordExtractor解析word03文件,出现文件中不存在的一个网址 使用POI的WordExtractor解析word文件的文本,提取出来的文本中出现此word文件内容中不存 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPkLjrM.html" rel="bookmark" class="title">收集的ROS防火墙脚本&lowbar;路由器、交换机</a>
					<div>
						# feb/18/2006 22:28:00 by RouterOS 2.9.2.7 QQ&quot;415736 # software id = 83RE-SN0 # / ip firewall f ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjnBQM.html" rel="bookmark" class="title">Gmail新版界面发布，主要功能一览</a>
					<div>
						根据Gmail官方博客报道,在对Gmail进行了重新设计和几周的用户测试之后,Gmail在今天发布了新版的界面,Gmail的用户可以切换到新版界面进行试用,而在目前,所有Gmail的用户登录邮箱,在G ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq7X9ez.html" rel="bookmark" class="title">阿里研究院崔瀚文：创新要素观该变了！</a>
					<div>
						创新要素就是实现创新所必不可少的最基本条件,不论是制度创新还是技术创新.产品创新.以往,创新要素是指人.财.物,及其组合的机制. 人类社会沧桑巨变,一切坚固的事物都不断经历着解构和重构,循环往复.周而 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyelWJM.html" rel="bookmark" class="title">ODPS 功能介绍之SQL</a>
					<div>
						ODPS 提供了SQL功能, 为BI工程师提供了大数据分析能力.ODPS的SQL语法与HQL非常相似,入手也非常容易.接下来就给大家介绍一下SQL的使用及一些优化技巧. SQL 语句分为三种:DDL. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXKxdyM.html" rel="bookmark" class="title">percona 实用工具之pt-kill使用介绍&lowbar;Mysql</a>
					<div>
						pt-kill 是一个优秀的kill MySQL连接的一个工具,是percona toolkit的一部分,在因为空闲连接较多导致超过最大连接数.某个有问题的sql导致mysql负载很高时,都需要将一些 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1NAEap.html" rel="bookmark" class="title">天天风之旅福娃和悟空哪个好 福娃与悟空技能对比分析</a>
					<div>
						技能对比 福娃技能: 喜气洋洋:把怪物变成羊,不造成伤害 进阶技能:福气多多,放收集物礼花,满级技能触发是攻击4只羊 满级装备:聚福宝盒 悟空技能: 定身咒:将怪物定住,打怪加分 进阶大闹天宫:专属杀 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBkmBdM.html" rel="bookmark" class="title">Windows服务初探</a>
					<div>
						Windows服务是独立于登录用户而工作的Windows应用程序,它通常在计算机启动时开始执行,且常常连续执行,直到计算机关闭为止.像Exchange Server,IIS和杀毒软件等都使用这种方式, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNv68xM.html" rel="bookmark" class="title">Google Sitemap 对google优化的作用</a>
					<div>
						那么Google Sitemap给搜索引擎优化带来什么重要的作用呢? 第一,像前面说的,能够让搜索引擎抓取的页面会更多,现在我们每个新站都会给他们添加一个网站地图使搜索引擎更好的抓取网站的内容. 第二 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj8e16p.html" rel="bookmark" class="title">关于淘宝客返佣金的问题</a>
					<div>
						问题描述 看到一些淘宝返利的网站,上面的所有的商品难道都是自己录入的吗??那么多还要和淘宝同步,手动录入应该不现实吗???忘高手指教,,谢谢! 解决方案 解决方案二:调用淘宝开放平台的API,正好我也 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAkKaZz.html" rel="bookmark" class="title">如何提取公司真实名称</a>
					<div>
						问题描述 就是我有一份公司信息数据,我要提取出每个公司名称并去重.现在的问题是:例1::&quot;江西省新余市某某农机有限公司&quot;和&quot;新余市晶丰农业机械制造有限公司&quot;其实 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGr68op.html" rel="bookmark" class="title">Instruments模板介绍（更新中&period;&period;&period;）</a>
					<div>
						第一章.Instruments(仪器)快速入门 Instruments可以用来收集关于一个或者多个系统进程的性能和行为的数据,并跟踪睡着时间产生的数据.它提供了好几个分析模板: Blank 任何类型都 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
